```@meta
CurrentModule = DelaunayTriangulation
```

# Triangulation 

The most important structure of the package is the Triangulation data structure. Its complete definition is given below, and then afterwards we give all the docstrings for methods that are useful for working with triangulations.

```@docs 
Triangulation
```

## Useful Methods 

```@docs 
get_adjacent(::Triangulation)
get_adjacent(::Triangulation, ::Any)
add_adjacent!(::Triangulation, ::Any)
delete_adjacent!(::Triangulation, ::Any)
get_adjacent2vertex(::Triangulation)
get_adjacent2vertex(::Triangulation, ::Any)
add_adjacent2vertex!(::Triangulation, ::Any, ::Any)
delete_adjacent2vertex!(::Triangulation, ::Any, ::Any)
delete_adjacent2vertex!(::Triangulation, ::Any)
get_graph(::Triangulation)
get_edges(::Triangulation)
get_vertices(::Triangulation)
get_neighbours(::Triangulation)
get_neighbours(::Triangulation, ::Any)
add_vertex!(::Triangulation, ::Vararg)
add_neighbour!(::Triangulation, ::Any, ::Vararg)
delete_neighbour!(::Triangulation, ::Any, ::Vararg)
delete_vertex!(tri::Triangulation, ::Vararg)
delete_boundary_vertices_from_graph!(::Triangulation)
get_boundary_nodes(::Triangulation)
has_multiple_curves(::Triangulation)
has_multiple_segments(::Triangulation)
num_curves(::Triangulation)
num_segments(::Triangulation)
get_boundary_nodes(::Triangulation, ::Vararg)
map_boundary_index(::Triangulation, ::Any)
get_curve_index(::Triangulation, ::Any)
get_segment_index(::Triangulation, ::Any)
get_right_boundary_node(::Triangulation, ::Any, ::Any)
get_left_boundary_node(::Triangulation, ::Any, ::Any)
get_convex_hull_indices(::Triangulation)
get_convex_hull(::Triangulation)
convex_hull!(::Triangulation)
triangle_type(::Triangulation)
get_triangles(::Triangulation)
num_triangles(::Triangulation)
each_triangle(::Triangulation)
each_solid_triangle(::Triangulation)
each_ghost_triangle(::Triangulation)
contains_triangle(::Triangulation, ::Any)
construct_positively_oriented_triangle(::Triangulation, ::Any, ::Any, ::Any)
edge_type(::Triangulation)
num_edges(::Triangulation)
each_edge(::Triangulation)
get_points(::Triangulation)
get_point(::Triangulation, ::Any)
each_point_index(::Triangulation)
each_point(::Triangulation)
num_points(::Triangulation)
is_boundary_edge(::Triangulation, ::Any)
get_boundary_map(::Triangulation)
get_boundary_index_ranges(::Triangulation)
is_boundary_triangle(::Triangulation, ::Any)
triangle_orientation(::Triangulation, ::Any)
point_position_relative_to_circumcircle(::Triangulation, ::Any, ::Any)
point_position_relative_to_line(::Triangulation, ::Any, ::Any, ::Any)
point_position_on_line_segment(::Triangulation, ::Any, ::Any, ::Any)
line_segment_intersection_type(::Triangulation, ::Any, ::Any, ::Any, ::Any)
point_position_relative_to_triangle(::Triangulation, ::Any, ::Any)
is_outer_boundary_index(tri::Triangulation, ::Any)
is_outer_boundary_node(tri::Triangulation, ::Any)
edge_exists(::Triangulation, ::Any)
has_ghost_triangles(::Triangulation)
has_boundary_nodes(::Triangulation)
brute_force_search(::Triangulation, ::Any)
jump_and_march(::Triangulation, ::Any)
integer_type(::Triangulation)
number_type(::Triangulation)
compute_representative_points!(::Triangulation)
clear_empty_features!(::Triangulation)
find_edge(::Triangulation, ::Any, ::Any)
get_constrained_edges(::Triangulation)
is_constrained(::Triangulation)
all_boundary_indices(::Triangulation)
```